package com.huigou.topsun.sap.nonProdApply.controller;


import com.huigou.cache.DictUtil;
import com.huigou.context.Operator;
import com.huigou.context.OrgUnit;
import com.huigou.topsun.proofing.domain.workInstructionApply.model.WorkInstructionApply;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyApplication;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyDeptApplication;
import com.huigou.topsun.sap.nonProdApply.domain.NonProdApplyBaseInfo;
import com.huigou.topsun.sap.nonProdApply.domain.SapNonProdApplyDept;
import com.huigou.topsun.sap.nonProdApply.domain.query.NonProdApplyBaseInfoQueryRequest;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.common.BizBillStatus;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import java.util.*;

@Controller
@ControllerMapping("/sapNonProdApplyNext")
public class NonProdApplyNextController extends CommonController {

    protected String getPagePath() {
        return "/biz/topsun/sap/nonProdApply/";
    }
    @Autowired
    NonProdApplyApplication nonProdApplyApplication;
    @Autowired
    NonProdApplyDeptApplication nonProdApplyDeptApplication;



    public String forwardNonProdApplyNext(){
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        NonProdApplyBaseInfo nonProdApplyBaseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(id);
        return forward("nonProdApplyNext",nonProdApplyBaseInfo);
    }

    public String slicedDeptList(){
        SDO sdo = this.getSDO();

        String septString = sdo.getString("dept");
        List<String> deptList = Arrays.asList(septString.split(","));
        Map<String, String> serviceusage = DictUtil.getDictionary("serviceusage");
         // 用于存储结果的字典
        Map<String, List<HashMap<String,String>>> map = new HashMap<>(); // 用于存储结果的字典
        List<HashMap<String, String>> list = new ArrayList<>();
        for (String key : deptList) {
            HashMap<String, String> resultMap = new HashMap<>();
            String value = serviceusage.get(key);
            resultMap.put("deptCode",key);
            resultMap.put("deptName", value);
            list.add(resultMap);
        }
        map.put("Rows",list);
        return toResult(map);
    }

    /**
     * 添加指导申请书
     */
    public String saveSapNonProdApplyDept(){
        SDO sdo = this.getSDO();
        SapNonProdApplyDept nonProdApplyDept = sdo.toObject(SapNonProdApplyDept.class);
        nonProdApplyDeptApplication.saveSapNonProdApplyDept(sdo);
        return toResult(nonProdApplyDept);
    }


    /**
     * 分发表单
     */
    public String distributeSapNonProdApplyDept(){
        SDO sdo = this.getSDO();
        SapNonProdApplyDept nonProdApplyDept = sdo.toObject(SapNonProdApplyDept.class);
//        nonProdApplyDeptApplication.saveSapNonProdApplyDept(sdo);
        return toResult(nonProdApplyDept);
    }

    /**
     * 填写收到的任务表单
     * @return
     */
    public String fillInNonProdApplyDept(){
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        this.putAttribute("isReadOnly","false");
        SapNonProdApplyDept nonProdApplyDept = nonProdApplyDeptApplication.getNonProdApplyDeptById(id);
        return forward("nonProdApplyNext",nonProdApplyDept);
    }
}


